<template>
  <div class="box p-5 md:p-8 mb-10">
    <form @submit.prevent="form.post('/creationhub/leaveType', { preserveScroll: true })" autocomplete="off">
      <h3>Create Leave Type</h3>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div class="flex flex-col w-full md:w-1/2 mr-2">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Leave Type Name</label>
              <input id="name" class="input w-full" type="text" placeholder="Enter leave type name"
                v-model="form.type" />
              <div v-if="form.errors.type" class="text-error">
                {{ form.errors.type }}
              </div>
            </div>
            <div class="flex flex-col w-full md:w-1/2">
              <label for="gender" class="text-sm font-medium text-gray-700 mb-2 mt-5">Balance Type</label>
              <select id="gender" class="dropdown w-full" v-model="form.balance_type">
                <option>Number</option>
                <option>Public Holiday</option>
                <option>Fixed</option>
                <option>Unlimited</option>
              </select>
              <div v-if="form.errors.balance_type" class="text-error">
                {{ form.errors.balance_type }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div v-if="form.balance_type === 'Public Holiday'" class="my-5 space-y-2">
        <div v-for="(ph, index) in form.public_holidays" class="border border-gray-400 p-3 rounded bg-gray-50">
          <div class="flex justify-between">
            <div class="text-sm">{{ index + 1 }}. Public Holiday</div>
            <button type="button" @click="form.public_holidays.splice(index, 1)">
              <Icon icon="fa-solid fa-trash-can" class="text-gray-400"></Icon>
            </button>
          </div>
          <div class="flex flex-col md:flex-row gap-3 ">
            <div class="flex-1">
              <div class="text-base">Name</div>
              <input v-model="form.public_holidays[index].name" class="input w-full" type="text">
              <div v-if="form.errors[`public_holidays.${index}.name`]" class="text-error">
                {{ form.errors[`public_holidays.${index}.name`] }}
              </div>
            </div>
            <div class="flex-1">
              <div class="text-base">Date (Year doesn't matter)</div>
              <input v-model="form.public_holidays[index].date" class="input w-full" type="date">
              <div v-if="form.errors[`public_holidays.${index}.date`]" class="text-error">
                {{ form.errors[`public_holidays.${index}.date`] }}
              </div>
            </div>
          </div>
        </div>
        <button class="block mx-auto italic text-base" type="button"
          @click="form.public_holidays.push({ 'name': '', 'date': null })">
          Click to add a Public Holiday +
        </button>
      </div>

      <div class="mt-7">
        <label class="block mb-2 text-sm font-medium text-gray-700 ">
          Who can approve leave applications of this type? (Define stages for each approver)</label>
        <multiselect v-model="approvers" :multiple="true" :options="users" label="name" track-by="id"
          :customLabel="(user) => `${user.name} (${user.role.name}) - CID ${user.cid}`">
        </multiselect>
        <div v-if="form.errors.approvers" class="text-error">
          {{ form.errors.approvers }}
        </div>

        <div class="mt-3">
          <div v-for="(approver, index) in form.approvers" class="mb-4">
            <Icon icon="fa-solid fa-user" class="text-base mr-2"></Icon>
            <label class="text-sm font-semibold">
              {{ approver.user.name }} ({{ approver.user.role.name }}) - CID {{ approver.user.cid }}
            </label>
            <div class="w-full flex gap-x-3 items-center">
              <div class="text-sm font-orange-500">
                Stage
              </div>
              <input v-model="form.approvers[index].stage" class="flex-1 input" placeholder="Enter leave approval stage"
                type="number" min="1">
            </div>

            <div v-if="form.errors[`${approver.user.id}id`]" class="text-error">
              {{ form.errors[`${approver.user.id}id`] }}
            </div>
          </div>
        </div>
      </div>

      <div class="w-full flex justify-center items-center ">
        <div class="flex w-full mb-2">
          <div class="md:flex flex-grow">
            <div v-if="form.balance_type === 'Number'" class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Monthly Balance
                Accumulation Rate
              </label>
              <input id="employee-name" class="input w-full" type="number" step="0.01"
                placeholder="Enter monthly accumulation rate" v-model="form.monthly_balance_accumulation_rate" />
              <div v-if="form.errors.monthly_balance_accumulation_rate" class="text-error">
                {{ form.errors.monthly_balance_accumulation_rate }}
              </div>
            </div>
            <div v-else-if="form.balance_type === 'Fixed'" class="flex flex-col w-full">
              <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                Fixed Balance
              </label>
              <input id="employee-name" class="input w-full" type="number" placeholder="Enter fixed balance"
                v-model="form.fixed_balance" />
              <div v-if="form.errors.fixed_balance" class="text-error">
                {{ form.errors.fixed_balance }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="text-base space-y-2">
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.carry_forward"
            :disabled="form.balance_type !== 'Number'">
          <label :class="{ 'opacity-30': form.balance_type !== 'Number' }">Carry Forward (The leave balances of
            users with this leave type will not reset)</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.requires_doc">
          <label>Requires Document</label>
        </div>
        <div class="flex items-center gap-x-2">
          <input type="checkbox" class="checkbox" v-model="form.requires_hod_approval">
          <label>Requires Head of Department's Approval (This approval comes before any other stages)</label>
        </div>
      </div>

      

      <div class="flex gap-x-3 mt-3 flex-row-reverse">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/creationhub/leaveType" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      </div>
    </form>
  </div>
</template>

<script setup>
import { Link, useForm } from '@inertiajs/vue3';
import { ref, watch } from 'vue';

defineProps({
  users: Array
})

const approvers = ref([]);

const form = useForm({
  type: '',
  requires_doc: false,
  requires_hod_approval: false,
  carry_forward: false,
  balance_type: 'Number',
  monthly_balance_accumulation_rate: 0.0,
  fixed_balance: 0,
  approvers: [],
  public_holidays: []
});

watch(approvers, (value) => {
  var oldApprovers = form.approvers;
  form.approvers = [];

  value.forEach((approver) => {
    var result = oldApprovers.find((oldApprover) => oldApprover.user.id === approver.id)
    if (result) {
      form.approvers.push({ user: approver, stage: result.stage })
    } else {
      form.approvers.push({ user: approver, stage: null })
    }
  })
})
</script>